#include <iostream>
#include <fstream>
#include <cstdio>
#include <iomanip>
#include <sstream>
#include <cstring>
#include <string>
#include <cmath>
#include <stack>
#include <list>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <numeric>
#include <utility>
#include <functional>
#include <limits>
#include "testlib.h"
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef pair<int,int> pii;
typedef vector<vector<int> > graph;

const double pi = acos(-1.0);

#define oned(a, x1, x2) { cout << #a << ":"; for(int _i = (x1); _i < (x2); _i++){ cout << " " << a[_i]; } cout << endl; }
#define twod(a, x1, x2, y1, y2) { cout << #a << ":" << endl; for(int _i = (x1); _i < (x2); _i++){ for(int _j = (y1); _j < (y2); _j++){ cout << (_j > y1 ? " " : "") << a[_i][_j]; } cout << endl; } }

#define mp make_pair
#define pb push_back
#define fst first
#define snd second

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    
    int LIM = 200000;

	int n = inf.readInt(2,LIM,"n"); inf.readSpace();
	int m = inf.readInt(1,LIM,"m"); inf.readSpace();
	int q = inf.readInt(1,LIM,"q"); inf.readEoln();

    if (validator.group() == "0")
    {
    }
    else if (validator.group() == "1")
    {
        ensure(n <= 200);
        ensure(m <= 200);
        ensure(q <= 200);
    }
    else if (validator.group() == "2")
    {
        ensure(n <= 2000);
        ensure(m <= 2000);
        ensure(q <= 2000);
    }
    else if (validator.group() == "5")
    {
        ensure(q <= 2000);
    }
	
	set<pii> S;
	for(int i = 1; i <= m; i++) {
		int a = inf.readInt(1,n,"a_i"); inf.readSpace();
		int b = inf.readInt(1,n,"b_i"); inf.readEoln();
		ensuref(a != b, "A loop");
		pii p(min(a,b),max(a,b));
		ensuref(S.find(p)==S.end(), "Multiple edges");
		S.insert(p);
	}
	
	for(int i = 1; i <= q; i++) {
		int l = inf.readInt(1,m,"l_i"); inf.readSpace();
		if (validator.group() == "3")
		{
			ensure(l == 1);
		}
		else if (validator.group() == "4")
		{
			ensure(l <= 200);
		}
		
		int r = inf.readInt(l,m,"r_i"); inf.readEoln();
	}

    inf.readEof();
}
