#include <sstream>
#include <set>

#include "testlib.h"

using namespace std;

int main(int argc, char *argv[])
{
    registerValidation(argc, argv);

    const int MAXN = 100000;
    const int MAXSUM = 1000000;

    int MAXN_G = 100000;
    int MAXSUM_G = 1000000;

    if (validator.group() == "0")
    {
    }
    else if (validator.group() == "1")
    {
        MAXN_G = 50;
        MAXSUM_G = 100;
    }
    else if (validator.group() == "2")
    {
        MAXN_G = 500;
        MAXSUM_G = 1000;
    }
    else if (validator.group() == "3")
    {
        MAXN_G = 5000;
        MAXSUM_G = 10000;
    }
    else if (validator.group() == "4")
    {
        // No further constraints
    }

    int Sf = inf.readInt(0, MAXSUM, "Sf"); inf.readSpace();
    int Pf = inf.readInt(0, MAXSUM, "Pf"); inf.readSpace();
    int Gf = inf.readInt(0, MAXSUM, "Gf"); inf.readEoln();
    ensure (Sf + Pf + Gf <= MAXSUM_G);
    ensure (Sf + Pf + Gf >= 1);


    int N = inf.readInt(1, MAXN, "N"); inf.readEoln();
    ensure(N <= MAXN_G);

    int mixesSeen = 0;
    std::set<int> mixesAvailable;
    for (int i = 1; i <= N; i++)
    {
        std::string cmd = inf.readToken("A|R", "cmd_i"); inf.readSpace();
        if (cmd == "A") {
            int Si = inf.readInt(0, MAXSUM, "Si"); inf.readSpace();
            int Pi = inf.readInt(0, MAXSUM, "Pi"); inf.readSpace();
            int Gi = inf.readInt(0, MAXSUM, "Gi");
            ensure (Si + Pi + Gi <= MAXSUM_G);
            ensure (Si + Pi + Gi >= 1);
            mixesAvailable.insert(++mixesSeen);
        } else {
            int a = inf.readInt(1, MAXN, "ri");
            ensure(mixesAvailable.find(a) != mixesAvailable.end());
            mixesAvailable.erase(a);
        }
        inf.readEoln();
    }

    inf.readEof();


}
