#include <sstream>
#include <set>

#include "testlib.h"

using namespace std;

const int MAXN = 100000;

struct Vertex{
    vector<int> to;
    bool visited;
}v[MAXN + 1];

int DFS(int it)
{
    if (v[it].visited)
        return 0;

    v[it].visited = true;
    int cnt = 1;
    for (auto t : v[it].to)
    {
        cnt += DFS(t);
    }
    return cnt;
}

int main(int argc, char *argv[])
{
    registerValidation(argc, argv);

    int N = inf.readInt(2, MAXN, "N"); inf.readEoln();

    set<pair<int, int>> edges;

    for (int i = 1; i < N; i++)
    {
        int a = inf.readInt(1, N, "Edge endpoint"); inf.readSpace();
        int b = inf.readInt(1, N, "Edge endpoint"); inf.readEoln();
        ensuref(a != b, "No self loops");

        v[a].to.push_back(b);
        v[b].to.push_back(a);

        if (a > b)
            swap(a, b);
        ensuref(edges.find({a, b}) == edges.end(), "No multi edges");
        edges.insert({a, b});
    }

    inf.readEof();

    // Check reachability
    ensuref(DFS(1) == N, "Possible to reach any other house");

    if (validator.group() == "0")
    {
    }
    else if (validator.group() == "1")
    {
        ensure(1 < N && N <= 10);
    }
    else if (validator.group() == "2")
    {
        ensure(10 < N && N <= 1000);
    }
    else if (validator.group() == "3")
    {
        // No further constraints
    }
}
