#include "testlib.h"

using namespace std;

using ll = long long;

const ll MAXN = 1000 * 1000 * 1000LL * 1000LL * 1000 * 1000;

int main(int argc, char *argv[])
{
    registerValidation(argc, argv);

    int G = inf.readInt(); inf.readSpace();
    int N = inf.readInt(); inf.readSpace();
    int M = inf.readInt(); inf.readEoln();

    ensure(G > 2);
    ensure(N >= G - 2);
    ensure(M >= 0);

    int kSum = 0;
    set<int> nonTerminals;
    for (int i = 1; i <= N; i++)
    {
        int a = inf.readInt(2, G - 1, "a"); inf.readSpace();
        int k = inf.readInt();
        ensure(k >= 1);

        kSum += k;
        nonTerminals.insert(a);

        for (int j = 1; j <= k; j++)
        {
            inf.readSpace();
            int b = inf.readInt(0, G - 1);
        }

        inf.readEoln();
    }

    ensure(kSum <= 100);
    for (int i = 2; i < G - 1; i++)
    {
        ensure(nonTerminals.count(i));
    }

    int lSum = 0;

    for (int i = 1; i <= M; i++)
    {
        int l = inf.readInt();
        ensure(l >= 1);

        lSum += l;

        for (int j = 1; j <= l; j++)
        {
            inf.readSpace();
            int c = inf.readInt(0, 1);
        }

        inf.readEoln();
    }

    ensure(lSum <= 50);

    inf.readEof();


    if (validator.group() == "0")
    {
        ensure(G == 6 && N == 6 && M == 2);
    }
    else if (validator.group() == "1")
    {
        ensure(M == 0);
    }
    else if (validator.group() == "2")
    {
        ensure(N == G - 2);
    }
    else if (validator.group() == "3")
    {
        ensure(M == 1);
    }
    else if (validator.group() == "4")
    {
        ensure(lSum <= 10);

    }
    else if (validator.group() == "5")
    {
        // No further constraints
    }
}
